tag @e[type=item_display,tag=bbln.block,distance=..32] add --bbln.loaded

execute store result score gamemode bbln.tmp run data get entity @s playerGameType
execute unless score gamemode bbln.tmp = @s bbln.player.gamemode run function bubblellaneous:player/event/world/change_gamemode

execute store result score @s bbln.player.pos_y run data get entity @s Pos[1]
execute if score @s bbln.player.leave matches 1.. run function bubblellaneous:player/event/world/leave
execute if score @s bbln.player.right_click matches 1.. run function bubblellaneous:player/event/item/right_click
execute if score @s bbln.player.sneak matches 1.. run function bubblellaneous:player/event/world/sneak
execute if score @s bbln.player.drop matches 1.. run function bubblellaneous:player/event/item/drop
execute if score @s bbln.player.death_count matches 1.. run function bubblellaneous:player/event/world/die

#region GUI
execute if entity @e[type=item_display,tag=bbln.name.bubble_bench,distance=..16] run function bubblellaneous:block/bubble_bench/as_player/tick
#endregion

#region Sound
scoreboard players remove @s[scores={bbln.player.sound=0..}] bbln.player.sound 1
execute if score @s bbln.player.sound matches 0 run function bubblellaneous:player/sound/play
#endregion

tag @s add --bbln.player
execute as @s[tag=--bbln.ladder.attached] run function bubblellaneous:block/ladder/player/tick
execute as @s[tag=--bbln.bear_trap.trapped] unless data entity @s RootVehicle run function bubblellaneous:block/bear_trap/player/tick
execute as @s[tag=--bbln.camera.spectating] run function bubblellaneous:block/surveillance_camera/player/tick
execute as @s[tag=--bbln.camera.leaving] at @s if loaded ~ ~ ~ if entity @e[type=armor_stand,tag=bbln.dummy_player,distance=..5] run function bubblellaneous:block/surveillance_camera/player/finish_leaving
execute as @s[tag=--bbln.flashlight.in_use] as @s[nbt={SelectedItem: {components: {"minecraft:custom_data": {bubblellaneous: {item_data: {id: "flashlight"}, item_properties: {is_turned_on: 1}}}}}}] anchored eyes positioned ^ ^ ^1 run function bubblellaneous:item/flashlight/tick
execute as @s[tag=--bbln.umbrella.using] as @s[nbt=!{SelectedItem: {components: {"minecraft:custom_data": {bubblellaneous: {item_data: {id: "umbrella"}}}}}}] run function bubblellaneous:item/umbrella/stop_flying
tag @s remove --bbln.player
tag @s remove --bbln.event_player
